<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of catSwitcher plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# catSwitcher is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# catSwitcher is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with catSwitcher; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

class catSwitcher {

	/**	
	@function readConf

	Cette fonction permet de lire le fichier de configuration de catSwitcher
	*/
	function readConf(){
		$catSwitcher_config_file = DC_SHARE_DIR.'/catSwitcher/catSwitcher.conf';

		$os = (DIRECTORY_SEPARATOR == '\\') ? 'win' : 'nix';
		
		# Transformation du chemin, forme std
		if ($os == 'win') $catSwitcher_config_file = str_replace('/','\\',$catSwitcher_config_file);

		if ( !file_exists($catSwitcher_config_file) ) {
			return false;
		}

		$catSwitcher_config = new iniFile($catSwitcher_config_file);
		$catSwitcher_config->read($catSwitcher_config_file);

		if ( !defined('CS_ACTIVE_JS') ||  !defined('CS_FIRST') ||
		     !defined('CS_LABEL_SUBMIT') ) {
			return false;
		}

		return true;
	}

	/**
	@function  catList

	Cette fonction affiche la liste des catgories, soit comme la mthode DcCatList()
	de DotClear ou sous forme de liste droulante, ou les deux.

	@param    mixed    cat_select   Catgories  afficher en tant que liste droulante.
	                                Ce paramtre peut tre :
	                                   + un tableau (listant les cat_libelle_url
	                                     ou cat_id des catgories)
	                                   + une expression rgulire (base sur les
	                                     cat_libelle_url)
	                                     ssi $regex_mode = true
	                                   + la valeur 'ALL' pour toutes les catgories
	
	@param    boolean  regex_mode   Active ou non le mode regex (true|false) pour cat_select

	@param    mixed    cat_deselect Catgories  ne pas afficher 
	                                Ce paramtre peut tre :
	                                   + un tableau (listant les cat_libelle_url
	                                     ou cat_id des catgories)
	                                   + une expression rgulire (base sur les
	                                     cat_libelle_url)
	                                     ssi $regex_mode = true

	@param    boolean  regex_mode2   Active ou non le mode regex (true|false)
	                                 pour cat_deselect

	@param    string   cat_block     Mise en forme du bloc "Catgories" avec les
	                                 catgories en dehors et dedans la liste
	                                 droulante (%1$s correspond aux catgories
	                                 et %2$d correspond  la liste droulante
	
	@param    string   block         Mise en forme de la liste des catgories
	                                 non comprises dans la liste droulante

	@param    string   item          Mise en forme des lments de la liste
	                                 des catgories non comprises dans la 
	                                 liste droulante
	*/

	function catList( $cat_select=array(), $regex_mode=false, 
	                  $cat_deselect=array(), $regex_mode2=false,
	                  $catblock='%1$s %2$s',
	                  $block='<ul>%s</ul>', $item='<li>%s</li>') {

		global $rs_cat, $cat_id, $lang, $blog;

		$comp_url = '';

		if ($lang) {
			$comp_url = $lang.'/';
		}

		if (!$rs_cat->isEmpty()) {

			// le formulaire qui contiendra la liste droulante et le bouton optionnel
			$form  = '';
			// $liens va contenir les tags qui sont en dehors de la liste droulante
			$liens = '';
			// $list va contenir la liste des <option>...</option>
			$list  = '';
			// Pour savoir si list est vide ou non
			$empty_list = true;

			# read configuration file
			$conf = catSwitcher::readConf();

			/* si la conf n'a pas pu tre lue, on va simplement afficher les catgories
			   comme avec la fonction d'origine, donc pas besoin des <option>...</option>
			   et Cie */
			if($conf) {
				// CS_FIRST value of the drop-down list
				$list = '<option value="" >'.CS_FIRST.'</option>';
			}

			while (!$rs_cat->EOF())	{
				
				if ($rs_cat->f('nb_post') > 0) {
					
					$id = $rs_cat->f('cat_id');
					$cat_url = $rs_cat->f('cat_libelle_url');
					$cat_libelle = $rs_cat->f('cat_libelle');

					if ( ( is_array($cat_deselect) && ( !in_array($id, $cat_deselect) && !in_array($cat_url, $cat_deselect) ) ) ||
					     ( $regex_mode2 && ( !ereg($cat_deselect,$cat_url) && !ereg($cat_deselect,$cat_libelle) ) )
					   ) {
					   	
					  /* Test pour savoir s'il doit tre dans la liste droulante
					     Si la conf n'a pas pu tre lue, on met tout dans une liste comme
					     d'hab cad pas ds la droulante */	

						if ( $conf &&
						     ( $cat_select === 'ALL' ) ||
						     ( is_array($cat_select) && ( in_array($id, $cat_select) || in_array($cat_url, $cat_select) ) ) ||
						     ( $regex_mode && ( ereg($cat_select,$cat_url) || ereg($cat_select,$cat_libelle) ) )
						   ) {
						  $empty_list = false;
							$list.='<option id="cS_option_'.$id.'" '.
							       'label="'.$cat_libelle.'" '.
							       'value="'.$id.'" '.(($cat_id == $cat_url || $cat_id == $id) ? 'selected ': '' ).' >'.
							       $cat_libelle.
							       '</option>';
						}
						else {
							$lien = '<a href="'.sprintf($blog->front_url['cat'],$comp_url.$cat_url).'">'.$cat_libelle.'</a>';

							if ($cat_id == $cat_url || $cat_id == $id) {
								$lien = '<strong>'.$lien.'</strong>';
							}

							$liens .= sprintf($item,$lien);
						}
					}
				}

				$rs_cat->moveNext();
			}

			$rs_cat->moveStart();
			
			if($conf && !$empty_list){
				$form = '<form id="cS_form" method="get" action="'.dc_blog_url.'" >'."\n".
				        '<p id="cS_p_form">'."\n".
				        '<select id="cS_select" name="cat" size="1" ';

				if(CS_ACTIVE_JS) $form.= 'onchange="this.form.submit();"';

				$form.= ' >'."\n".
				        $list."\n".
				        '</select>'."\n".
				        '<input id="cS_submit" type="submit" value="'.CS_LABEL_SUBMIT.'" />'."\n".
				        '</p>'."\n".
				        '</form>'."\n";
			}

			if( $liens != '') $liens = sprintf($block, $liens);

			printf($catblock,$liens,$form);
		}
	}


	/**
	@function       hideSubmitButton

	Cette fonction permet d'afficher ou non le bouton "Go" (ou "Aller" en
	franais :) ) affich  ct de la liste droulante. Cette fonction
	permet simplement d'inclure un fichier javascript qui :

		1 - Si javascript est activ et le paramtre active de la fonction est  true, permet
		    d'effacer el bouton ( l'aide de DOM et Cie)

		2 - Si javascript est activ et le paramtre active est  false, laisse le bouton

		3 - si javascript n'est pas activ, affiche le bouton.

	*/


	function hideSubmitButton(){
		# read conf
		if ( !($conf = catSwitcher::readConf()) ) exit;

		if (CS_ACTIVE_JS)		
			echo '  <script src="'.dc_app_url.'/ecrire/tools/catSwitcher/catSwitcher.js" type="text/javascript"></script>'."\n"; 
	}

}

?>
