<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of arcSwitcher plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# arcSwitcher is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# arcSwitcher is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with arcSwitcher; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

function catSwitcher_error($error) {
	buffer::str('<div class="error">'.__('ERROR:').' '.$error.'</div>');
}


function catSwitcher_form_config(){
	global $url;

	$CS_ACTIVE_JS    = (defined('CS_ACTIVE_JS'))    ? CS_ACTIVE_JS    : '';
	$CS_FIRST        = (defined('CS_FIRST'))        ? CS_FIRST        : '';
	$CS_LABEL_SUBMIT = (defined('CS_LABEL_SUBMIT')) ? CS_LABEL_SUBMIT : '';

	buffer::str('<h3>'.__('catSwitcher Configuration').'</h3>');

	buffer::str('<form action="'.$url.'" method="post">');

	# checkbox : catSwitcher_activejs
	buffer::str('<p>'.form::checkbox('catSwitcher_activejs','true',$CS_ACTIVE_JS,'','catSwitcher_activejs').
	            __('Activate catSwitcher Javascript').' '.
	            helpLink('catSwitcher_config&plugin=catSwitcher','catSwitcher_activejs').
	            '</label>'.'</p>');

	# field : catSwitcher_CS_FIRST
	buffer::str('<p>'.
	            '<label for="catSwitcher_CS_FIRST">'.
	            '<strong>'.__('catSwitcher CS_FIRST value').'&nbsp;: </strong> '.
	            helpLink('catSwitcher_config&plugin=catSwitcher','catSwitcher_CS_FIRST').
	            '</label>'.
	            form::field('catSwitcher_CS_FIRST',40,255,$CS_FIRST,'','class="max"').
	            '</p>');

	# field : catSwitcher_labelsubmit
	buffer::str('<p>'.
	            '<label for="catSwitcher_labelsubmit">'.
	            '<strong>'.__('catSwitcher submit button label').'&nbsp;: </strong> '.
	            helpLink('catSwitcher_config&plugin=catSwitcher','catSwitcher_labelsubmit').
	            '</label>'.
	            form::field('catSwitcher_labelsubmit',40,255,$CS_LABEL_SUBMIT,'','class="max"').
	            '</p>');

	buffer::str('<br />');

	buffer::str('<p><input class="submit" type="submit" name="submit" value="'.
	            __('save').'" /></p>');
	buffer::str(form::hidden('updConfig','true'));
	# ajout du None pour compatibilit avec DC1.2.7
	buffer::str('<p>'.dcNonce::form().'</p>');
	buffer::str('</form>');

}


function catSwitcher_save_config(){
	global $catSwitcher_config;

	$catSwitcher_activejs    = (!empty($_POST['catSwitcher_activejs']))    ? $_POST['catSwitcher_activejs']    : 'false';
	$catSwitcher_CS_FIRST       = (!empty($_POST['catSwitcher_CS_FIRST']))       ? $_POST['catSwitcher_CS_FIRST']       : '---';
	$catSwitcher_labelsubmit = (!empty($_POST['catSwitcher_labelsubmit'])) ? $_POST['catSwitcher_labelsubmit'] : 'Go';

	$catSwitcher_config->editVar('CS_ACTIVE_JS', $catSwitcher_activejs);
	$catSwitcher_config->editVar('CS_FIRST', $catSwitcher_CS_FIRST);
	$catSwitcher_config->editVar('CS_LABEL_SUBMIT', $catSwitcher_labelsubmit);

	if( $catSwitcher_config->saveFile() ){
		buffer::str('<p>'.__('Configuration saved.').'</p>');
		catSwitcher_help();
	}
	else {
		catSwitcher_error(__('Impossible to write in configuration file.'));
	}
}


function catSwitcher_help() {
	global $blog;
	
	buffer::str('<fieldset class="clear"><legend>'.__('Modify your template.php').'</legend>');

	buffer::str('<p>'.__('To use catSwitcher, it\'s very simple:').'</p>');

	buffer::str('<ol><li>'.__('Find in your template.php the bloc about the categories:'));

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<div id="categories">').'<br />');
	buffer::str('&nbsp;&nbsp;&nbsp;&nbsp;'.htmlspecialchars('<h2>'.__('Categories').'</h2>').'<br />');
	buffer::str('&nbsp;&nbsp;&nbsp;&nbsp;'.htmlspecialchars('<?php dcCatList(); ?>').'<br />');
	buffer::str(htmlspecialchars('</div>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('And remplace it by:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<div id="categories">').'<br />');
	buffer::str('&nbsp;&nbsp;&nbsp;&nbsp;'.htmlspecialchars('<h2>'.__('Categories').'</h2>').'<br />');
	buffer::str('&nbsp;&nbsp;&nbsp;&nbsp;<b>'.htmlspecialchars('<?php catSwitcher::catList(); ?>').'</b><br />');
	buffer::str(htmlspecialchars('</div>'));
	buffer::str('</div>');

	buffer::str('</li>');

	buffer::str('<li>'.__('Find in your template.php this line (in head bloc):'));

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<link rel="stylesheet" type="text/css" href="<?php dcInfo(\'theme\'); ?>/style.css" media="screen" />'));
	buffer::str('</div>');

	buffer::str('<p>'.__('And add this line (in bold):').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<link rel="stylesheet" type="text/css" href="<?php dcInfo(\'theme\'); ?>/style.css" media="screen" />').'<br />');
	buffer::str('<b>'.htmlspecialchars('<?php catSwitcher::hideSubmitButton(); ?>').'</b>');
	buffer::str('</div>');

	buffer::str('</li>');

	buffer::str('</ol>');

	buffer::str('</fieldset>');

	buffer::str('<fieldset class="clear"><legend>'.__('How catSWitcher wokrs (parameters and Co)').'</legend>');

	buffer::str('<p>'.__('catSwitcher::catList() works like dcCatList() by default.').'</p>');
	buffer::str('<p>'.__('Categories that are not in the drop-down list are print like with dcCatList().').'</p>');

	buffer::str('<p>'.__('But it accept parameters').' :D. '.__('You can give it an array with the categories to include in the drop-down list.').' '.
		__('This array must contain the \'cat_libelle_url\' string of the categories (i.e. spaces remplaced by _, without accentued chars, etc).').'</p>');

	buffer::str('<br />');

	buffer::str('<p>'.__('Take this list of categories for example:').'</p>');
	buffer::str('<ul><li>'.__('General').'</li>');
	buffer::str('<li>'.__('Blog of Marie').'</li>');
	buffer::str('<li>'.__('Blog of Gustave').'</li>');
	buffer::str('<li>'.__('Summer').'</li>');
	buffer::str('<li>'.__('Winter').'</li></ul>');

	buffer::str('<p>'.__('If you want to include "Summer" and "Winter" in your drop-down list, you\'ll use:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php catSwitcher::catList( array(\''.$blog->str2url(__('Summer')).'\',\''.$blog->str2url(__('Winter')).'\') ); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('But it\'s not all folks !').' '.__('You can use regular expressions.').' '.__('For example, if you want to include all categories that begin with \'Blog\' in your drop-down list, you\'ll use:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php catSwitcher::catList( \'^Blog\', true ); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('The second parameter active the regex mode (false by default)').'</p>');

	buffer::str('<p>'.__('If you want to include all categories in your drop-down list, catSwitcher use a special parameter:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php catSwitcher::catList( \'ALL\' ); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('If you want to include all categories in your drop-down list but you don\'t want to view \'General\' category in your lists (normal and drop-down), you\'ll use:').'</p>'); 

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php catSwitcher::catList(\'ALL\', false, array(\''.__('General').'\')); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('The two CS_FIRST parameters do not change and have the same signification. The third parameter has the same signification that the CS_FIRST parameter: it can be an array of categories to not print, or a regular expression which will be activate with the fourth parameter set to true.').'</p>');
	buffer::str('<p>'.__('By example, if you don\'t want to print all categories that begin with \'Cat\', you\'ll use:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php catSwitcher::catList(\'ALL\', false, \'^Cat\', true); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('Another example. If you don\'t want to print \'General\' category and you want to include all the categories that begin with \'Blog\' in your drop-down list, the remaining categories will be in normal list as usual, you\'ll use:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php catSwitcher::catList(\'^Blog\', true, array(\''.__('General').'\')); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('Last example. You don\'t want to print all categories that begin with \'Cat\', and you want to include \'General\', \'House\' and \'Holidays\' in your drop-down list, you\'ll use:').'</p>'); 

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php catSwitcher::catList(array(\''.__('General').'\', \''.__('House').'\', \''.__('Holidays').'\'), false, \'^Cat\', true); ?>'));
	buffer::str('</div>');

	buffer::str('<br />');

	buffer::str('<p>'.__('You can format the categories bloc.').' '.__('For example:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php catSwitcher::catList( \'^Blog\', true, \'<div>%1$s</div><div>Blogs : %2$s</div>\', \'<ul>%s</ul>\', \'<li>%s</li>\' ); ?>'));
	buffer::str('</div>');

	buffer::str('<ul><li>');
	buffer::str('<b>\''.htmlspecialchars('<div>%1$s</div><div>Blogs : %2$s</div>').'\'</b> '.__('is the entiere categories bloc, with simple list and drop-down list').'. '.
		__('The CS_FIRST %1$s is the simple list.').' '.__('The second %2$s is the drop-down list.').'</li>');
	buffer::str('<li><b>\''.htmlspecialchars('<ul>%s</ul>').'\'</b> '.__('and').' <b>\''.htmlspecialchars('<li>%s</li>').'\'</b> '.__('is the simple list format like in the function dcCatList()').'.</li></ul>');

	buffer::str('</fieldset>');
}

?>
