<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of catSwitcher plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# catSwitcher is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# catSwitcher is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with catSwitcher; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

$error = '';

# configuration de catSwitcher
require_once $_SERVER['DOCUMENT_ROOT'].'/'.dc_app_url.'/inc/classes/class.ini.file.php';

# petite correction de la mthode files::makeDir de faon  ce que cette dernire
# renvoie true si tout est OK. Par dfaut elle ne renvoie rien si tout est OK et
# FALSE s'il y a un pb lors du mkdir...
function makeDir($f){
		if (@mkdir($f,fileperms(dirname($f))) === false) {
			return false;
		}
		
		return @chmod($f,fileperms(dirname($f)));
}


$catSwitcher_config_file = DC_SHARE_DIR.'/catSwitcher/catSwitcher.conf';

$os = (DIRECTORY_SEPARATOR == '\\') ? 'win' : 'nix';
		
# Transformation du chemin, forme std
if ($os == 'win') $catSwitcher_config_file = str_replace('/','\\',$catSwitcher_config_file);

# cration du rpertoire
if (!file_exists(dirname($catSwitcher_config_file))) {
	if ( !makeDir(dirname($catSwitcher_config_file)) ) {
		$error = sprintf(__('Immpossible to create %s directory.'),dirname($catSwitcher_config_file));
	}
}

# cration du fichier de conf de base
if ($error == '' && !file_exists($catSwitcher_config_file)) {
	if ( !touch($catSwitcher_config_file) ) {
		$error = sprintf(__('Impossible to create %s configuration file.'), $catSwitcher_config_file);
	}
	else {
		$fp = fopen($catSwitcher_config_file, 'w');
		if ( !fwrite($fp, 'CS_ACTIVE_JS = true'."\n".'CS_FIRST = ---'."\n".'CS_LABEL_SUBMIT = Go') ){
			$error = __('Impossible to write in configuration file.');
		}
	}
}

if ($error == '') {
	$catSwitcher_config = new iniFile($catSwitcher_config_file);
	$catSwitcher_config->read($catSwitcher_config_file);
	if ( !defined('CS_ACTIVE_JS') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'CS_ACTIVE_JS');
	}
	elseif ( !defined('CS_FIRST') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'CS_FIRST');
	}
	elseif ( !defined('CS_LABEL_SUBMIT') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'CS_LABEL_SUBMIT');
	}
}


# Rcupration du fichier de langue pour la page Help
#if (dc_encoding == 'UTF-8') {
#        l10n::set(dirname(__FILE__).'/l10n/'.DC_LANG.'-utf8/help');
#}
#else {
#        l10n::set(dirname(__FILE__).'/l10n/'.DC_LANG.'/help');
#}


# les fonctions pour l'interface admin
#require_once dirname(__FILE__).'/inc/function_admin.php';
require_once 'inc/admin_functions.php';

# style supplmentaire pour l'interface admin
$PLUGIN_HEAD =  '  <style type="text/css"> @import "tools/catSwitcher/main.css"; </style>'."\n";

$url = 'tools.php?p=catSwitcher';

# pour l'affichage de la page de configuration de catSwitcher
$config = (!empty($_GET['config'])) ? $_GET['config'] : '';

# pour l'enregistrement de la configuration
$updConfig = (!empty($_POST['updConfig'])) ? $_POST['updConfig'] : 'false';

# pour l'affichage de la page d'aide
$help = (!empty($_GET['help'])) ? $_GET['help'] : '';

# page d'aide affiche par dfaut
if ($config=='' && $updConfig == 'false') $help = '1';

$version = $plugins_list['catSwitcher']['version'];


# titre de la page d'administration du plugin catSwitcher 
buffer::str('<h2>catSwitcher '.$version.'</h2>');


# le menu de catSwitcher
buffer::str('<div id="menu">'.
    '<a href="'.$url.'&config=1" '.(($config!='') ? 'id=selected':'').' >'.__('Configuration').'</a>'.
    '<a href="'.$url.'&help=1" '.(($help!='') ? 'id=selected':'').' >'.__('Help').'</a>'.
    '</div>');
buffer::str('<br />');

if ( $error != '' ) {
  catSwitcher_error($error);
}
else {
    if ($config == '1') {
      catSwitcher_form_config();
    }

    # sinon on enregistre la configuration
    elseif ($updConfig == 'true') {
      catSwitcher_save_config();
    }

    # sinon on affiche l'aide d'arcSwitcher
    elseif ($help == '1') {
      catSwitcher_help();
    }
}

?>
